#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>

#include <WSCmessageDialog.h>

typedef long (WINAPI *PSHEnumValue)(HKEY hkey, DWORD dwIndex, LPSTR pszValueName, LPDWORD pcchValueName, LPDWORD pdwType, LPVOID pvData, LPDWORD pcbData); 

#include "mainwin.h"

#include "crc.h"
#include "util.h"

extern "C" void messagebox (const char *str)
{
	WSCmessageDialog* msg = WSGIappMessageDialog ();
	msg->setProperty (WSNwidth,300);
	msg->setProperty (WSNheight,200);
	msg->setProperty (WSNdefaultPosition,True);
	WSCstring strtmp = (char *)str, strret = "\n";
	for (long i = 0; i < strtmp.getChars (); i += 41) {
		strtmp.insertString (i, strret);
	}
	msg->setProperty (WSNlabelString, (char *)strtmp);
	msg->popup ();
}

extern "C" void consoleout (const char *str)
{
	static int r_chars = 0;
	if (r_chars) {
		txtConsole->setSelect ((txtConsole->getString ()).getChars () - r_chars, r_chars);
		txtConsole->deleteSelectedString ();
	}
	txtConsole->addString ((char *)str);
	int len = strlen (str);
	if (str[len - 1] != '\r') {
		txtConsole->setBottomLine (txtConsole->getLines ());
		r_chars = 0;
	}
	else {
		txtConsole->setBottomLine (txtConsole->getLines () + 1);
		r_chars = len;
	}
}

//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
void mainwin_init(WSCbase* object){
  //do something...
	WSCmessageDialog* msg = WSGIappMessageDialog ();
	msg->setProperty (WSNwidth,300);
	msg->setProperty (WSNheight,200);
	msg->setProperty (WSNdefaultPosition,True);
	
	HINSTANCE hDll = LoadLibrary ("shlwapi.dll");
	if(!hDll) {
		msg->setProperty (WSNlabelString, "Can't load dll.");
		msg->popup ();
		exit (-1);
	}
	PSHEnumValue SHEnumValue = (PSHEnumValue)GetProcAddress (hDll, "SHEnumValueA"); 
	if (!SHEnumValue) {
		msg->setProperty (WSNlabelString, "Bad dll.");
		msg->popup ();
		exit (-1);
	}
	
	init_crc32 ();
	
	HKEY		hKey;
	int			i;
	char		szName[MAX_PATH], szValue[MAX_PATH];
	DWORD		dwNameSize, dwValueSize, dwType;
	WSCstring	str1, strall;
	RegOpenKeyEx (HKEY_LOCAL_MACHINE, "Hardware\\DeviceMap\\SerialComm", 0, KEY_ALL_ACCESS, &hKey);
	for (i = 0; ; i++)	{
		dwNameSize = sizeof (szName);
		dwValueSize = sizeof (szValue);
		if (ERROR_SUCCESS != SHEnumValue (hKey, i, szName, &dwNameSize, &dwType, szValue, &dwValueSize))	{
			break;
		}
		if (!i) {
			strall = str1 = szValue;
		}
		else {
			strall += ",";
			strall += szValue;
		}
	}
	FreeLibrary (hDll);
	cmbPort->setProperty (WSNmenuItems, strall);
	cmbPort->setProperty (WSNlabelString, str1);
}
static WSCfunctionRegister  op("mainwin_init",(void*)mainwin_init);
